> ## Documentation Index
> Fetch the complete documentation index at: https://docs.sonderplan.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Projects

> In Sonderplan a project represents a container for grouping related bookings, files, quotes and invoices. Projects allow users to organize their work by associating bookings with a specific purpose, client, or final deliverable (such as a movie or commercial).

Projects include metadata such as the project name, client information, deadlines, files, and any custom attributes defined (via custom fields) by the user. This helps streamline project management and reporting by keeping all relevant details in one place.

<Note>`READ` access to the `PROJECT` module is required to access this endpoint</Note>



## OpenAPI

````yaml /api-reference/openapi-mintlify.yaml get /v2/project
openapi: 3.0.0
info:
  title: Sonderplan API
  description: >
    ## Overview

    You can use our REST API to securely access and modify the data within your
    Sonderplan account. This includes all the information within your bookings,
    projects and invoices that you can use to import / export data or create
    integrations with other systems and software that you use


    ### General Notes


    #### Specifying Fields

    The Sonderplan REST API allows you to specify a comma delimited string of
    exactly which fields are returned, using the `fields` parameter. Using this
    parameter has several advantages including:


    1. In future API versions we may change which fields are presented by
    default, so explicitly specifying the fields required overrides the defaults
    and ensure the fields are served

    2. Limiting fields reduces the processing we need to do and allows us to
    send you the data faster

    3. Some search filters only work if the field you are searching is added to
    the `fields` parameter.


    Example:


    ```

    fields=id,name,start,duration_min

    ```


    ### Applying Filters


    The Query Parameters section in each endpoint shows you special options that
    can be added to your request to customise the response we send you.


    Most endpoints offer the following query params:


    | Query Parameter |
    Description                                                    |

    |-----------------|----------------------------------------------------------------|

    | `fields`        | Only send the specified
    fields                                 |

    | `id`            | Specify one or more ids (comma seperated) of records to
    return |

    | `limit`         | The maximum number of records to
    return                        |

    | `page`          | The page number of records to
    return                           |

    | `order_asc` | Specify which field should be used to sort records
    `ascending` |

    | `order_desc` | Specify which field should be used to sort records
    `descending` |


    In addition to the standard `id` param, you can also specify most other
    fields as a query parameter, useful for performing searching and filtering
    of records.


    For example, you can specify `repeat_master_id=<repeat_booking_id>` to
    return all repeat children of that booking.


    #### Other Query Params


    Refer to the specific API endpoint documentation to see which other query
    params can be used.


    For example, some endpoints allow specifying `updated_after=<UNIX
    TIMESTAMP>` which will only send added, edited and even deleted records that
    were modified after the unix timestamp.


    #### Applying multiple filters


    By default, multiple filters are chained together using **OR** (either
    filter can be true and it will be included). You can change this behaviour
    by specifying `filter_operator=AND`, so each filter must be true to be
    included.


    #### Filtering by Custom Field Values


    For modules that include custom fields, you can search by the value of a
    custom field by adding the `custom_field_<field id>` to the URL query
    parameters. You **must** also specify the custom field in the `fields`
    parameter.


    ```

    GET
    https://api.sonderplan.com/v2/booking?fields=id,name,custom_field_238938&custom_field_238938=Offline

    ```


    This will return custom fields that contain the word 'Offline'.
  contact:
    email: info@sonderplan.com
  version: '2.0'
servers:
  - url: https://api.sonderplan.com
    description: Production Server
security: []
tags:
  - name: Booking
    description: Booking related operations
  - name: Project
    description: Project related operations
  - name: Resource
    description: Resource related operations
  - name: Contact
    description: Contact related operations
  - name: Quote
    description: Quote related operations
  - name: Invoice
    description: Invoice related operations
  - name: Invoice Template
    description: Invoice template related operations
  - name: Billable Item
    description: Billable item related operations
  - name: Rate Scheme
    description: Rate scheme related operations
  - name: Tax
    description: Tax related operations
  - name: Workspace
    description: Workspace (formerly Schedule) related operations
  - name: User
    description: User related operations
  - name: Group
    description: Group related operations
  - name: Status
    description: Status related operations
  - name: Custom Field
    description: Custom field related operations
  - name: Calendar Subscription
    description: Calendar Subscription Import related operations
  - name: Time Entry
    description: Time Entry related operations
  - name: Time Activity
    description: Time Activity related operations
paths:
  /v2/project:
    get:
      tags:
        - Project
      summary: Get Projects
      description: >-
        In Sonderplan a project represents a container for grouping related
        bookings, files, quotes and invoices. Projects allow users to organize
        their work by associating bookings with a specific purpose, client, or
        final deliverable (such as a movie or commercial).


        Projects include metadata such as the project name, client information,
        deadlines, files, and any custom attributes defined (via custom fields)
        by the user. This helps streamline project management and reporting by
        keeping all relevant details in one place.


        <Note>`READ` access to the `PROJECT` module is required to access this
        endpoint</Note>
      operationId: 18636e14983eb62a55dffee8364ab01b
      parameters:
        - name: id
          in: query
          description: One or more (comma seperated) IDs of projects to retrieve
          schema:
            type: string
            format: string
        - name: name
          in: query
          description: Perform a partial match text search for the project name
          schema:
            type: string
        - name: code
          in: query
          description: Perform a partial match text search for the project code
          schema:
            type: string
        - name: description
          in: query
          description: Perform a partial match text search for the project description
          schema:
            type: string
        - name: status_id
          in: query
          description: Perform an exact match for the project status_id
          schema:
            type: integer
        - name: private
          in: query
          description: Perform an exact match for the project private boolean
          schema:
            type: boolean
        - name: parent_folder_id
          in: query
          description: Perform an exact match for the project parent_folder_id
          schema:
            type: integer
        - name: color_background
          in: query
          description: >-
            Perform a partial match text search for the projects background
            color
          schema:
            type: string
        - name: color_text
          in: query
          description: Perform a partial match text search for the projects text color
          schema:
            type: string
        - name: active_from
          in: query
          description: Filter projects that have a `end` greater than this value
          schema:
            type: string
        - name: active_to
          in: query
          description: Filter projects that have a `start` lesser than this value
          schema:
            type: string
        - name: updated_from
          in: query
          description: Filter projects where `updated` is greater than this value
          schema:
            type: string
        - name: updated_to
          in: query
          description: Filter projects where `updated` is lesser than this value
          schema:
            type: string
        - $ref: '#/components/parameters/updated_after'
        - $ref: '#/components/parameters/fields'
        - $ref: '#/components/parameters/page'
        - $ref: '#/components/parameters/limit'
        - $ref: '#/components/parameters/order_asc'
        - $ref: '#/components/parameters/order_desc'
        - $ref: '#/components/parameters/filter_operator'
      responses:
        '200':
          description: Successful Operation
          content:
            application/json:
              schema:
                properties:
                  data:
                    type: array
                    items:
                      $ref: '#/components/schemas/Project'
                  meta:
                    $ref: '#/components/schemas/pagination'
                type: object
        '401':
          description: Authorization information is missing or invalid
      security:
        - bearer: []
components:
  parameters:
    updated_after:
      name: updated_after
      in: query
      description: >-
        Return results that were added, edited or deleted since this UNIX
        timestamp
      schema:
        type: integer
        format: int32
    fields:
      name: fields
      in: query
      description: Comma seperated list of fields you wish to return
      schema:
        type: string
      example: id,name
    page:
      name: page
      in: query
      description: Specify the page of results you wish to return
      schema:
        type: integer
    limit:
      name: limit
      in: query
      description: The number of results returned per page. Default if not specified is 10
      schema:
        type: integer
    order_asc:
      name: order_asc
      in: query
      description: >-
        Specify the field (with type of string or integer) you wish to order
        (ascending) the response with
      schema:
        type: string
    order_desc:
      name: order_desc
      in: query
      description: >-
        Specify the field (with type of string or integer) you wish to order
        (descending) the response with
      schema:
        type: string
    filter_operator:
      name: filter_operator
      in: query
      description: Specify if multiple filters should be combined with OR or AND logic
      schema:
        type: string
        default: OR
        enum:
          - OR
          - AND
  schemas:
    Project:
      title: Project Model
      description: The default project schema which contains the majority of these fields
      type: object
      allOf:
        - properties:
            id:
              description: Automatically generated Project ID
              type: integer
              readOnly: true
              example: 2342354
            name:
              description: Title of the project
              type: string
              example: Andor S1 EP7 Annoucement
            code:
              description: Short code used to identify the project
              type: string
              example: AND-S1-EP7
            description:
              description: A short description or synopsis of the project
              type: string
              example: >-
                Colonel Yularen announces that the ISB has gained more
                surveillance and punitive authority, while Meero is challenged
                by Blevin for breaking protocol by accessing Imperial data
                without authorization.
            status_id:
              description: Project Status ID
              type: integer
              writeOnly: true
              example: 1
            status:
              type: array
              items:
                $ref: '#/components/schemas/StatusSummary'
            private:
              description: >-
                Is the project viewable to everyone, or just the users and
                groups assigned
              type: boolean
              example: 0
            parent_folder_id:
              description: The ID of the folder that this project is sitting in
              type: integer
              example: 5
            color_background:
              description: Hex color value of the background
              type: string
              example: '#B0A7F1'
            color_text:
              description: Hex color value of the text
              type: string
              example: '#000000'
            start:
              description: Unix Timestamp of the project start time frame.
              type: integer
              example: 1547501100
            end:
              description: Unix timestamp of the project end time frame.
              type: integer
              example: 1547538900
            client_id:
              description: >-
                The ID of the client prefixed by either p (for person) or o (for
                organization)
              type: string
              writeOnly: true
              example: p23987
            client:
              description: >-
                The client (either person or organization) attached to this
                project
              type: array
              items:
                $ref: '#/components/schemas/Client'
            custom_fields:
              type: array
              items:
                $ref: '#/components/schemas/CustomFieldOnObject'
            people:
              description: >-
                The users and groups assigned to this project. Also contains
                information regarding project admin status and role information
              properties:
                users:
                  type: array
                  items:
                    $ref: '#/components/schemas/ProjectUser'
              type: object
            time_entries:
              type: array
              items:
                $ref: '#/components/schemas/ProjectTimeEntries'
          type: object
        - $ref: '#/components/schemas/extendedModelMeta'
    pagination:
      title: Pagination Meta Model
      properties:
        pagination:
          $ref: '#/components/schemas/meta'
      type: object
    StatusSummary:
      title: Status Summary Model
      description: A simplified version of the complete Status Model
      properties:
        id:
          description: Automatically generated unique identifier of the status
          type: integer
          readOnly: true
          example: 2
        name:
          description: The name of the status
          type: string
          example: Second Hold
        description:
          description: Description of the status
          type: string
          example: Has second priority if the first hold cancels
        notification:
          description: Determines if notifications are sent if this status is selected
          type: boolean
          example: true
      type: object
    Client:
      title: Client model
      description: Client model with some fields
      properties:
        id:
          type: integer
          readOnly: true
          example: 4
        uuid:
          type: string
          example: p4
        name:
          type: string
          readOnly: true
          example: Jane Someone
        type:
          type: string
          enum:
            - person
            - organization
          readOnly: true
          example: person
        email:
          description: The primary email for this contact
          type: string
          readOnly: true
          example: test@example.com
        contact_person:
          description: >-
            Contact person at the client. This property is only valid if the
            client is of type **organization**, and the contact must be a valid
            client
          properties:
            id:
              type: integer
              example: 2837
            name:
              type: string
              readOnly: true
              example: Fred Flintstone
          type: object
      type: object
    CustomFieldOnObject:
      title: Custom Field Module Value
      description: Used to show the values of custom fields on linked modules
      properties:
        id:
          description: The ID of the custom field
          type: integer
          example: 7823
        name:
          description: The name of the custom field
          type: string
          example: Type
        value:
          description: The text value of the custom field, null if not defined
          type: string
          example: Video Editing
        value_id:
          description: >-
            The ID of the selected option, (applied only if the custom field is
            of type `select`)
          type: integer
          example: 8973
        update_key:
          description: The update key to pass back when updating this field
          type: string
          example: '2_1_7823'
          deprecated: true
      type: object
    ProjectUser:
      title: Project members user model
      description: Limited fields user model
      properties:
        id:
          type: integer
          example: 4
        name:
          type: string
          example: Jane Smith
        admin_flag:
          type: integer
          example: 0
        role_id:
          type: integer
          example: 0
        role_name:
          type: string
          example: 0
        project_admin:
          type: boolean
          example: true
        group_write_admin:
          type: boolean
          example: false
      type: object
    ProjectTimeEntries:
      title: Project Time Entries Model
      description: The time entries attached to a project
      type: object
      allOf:
        - properties:
            id:
              description: Automatically generated, unique time entry id
              type: integer
              readOnly: true
              example: 9879871
            owner_id:
              description: ID of the user that owns this time entry
              type: integer
              example: 872383
            name:
              description: Name of the activity that is being worked on
              type: string
              example: Colour Grading
            description:
              description: Short description or notes about what was worked on
              type: string
              example: Opening scenes completed
            start:
              description: Unix Time Entry Start
              type: integer
              example: 1547501100
            end:
              description: Unix Time Entry End
              type: integer
              example: 1547538900
            booking_id:
              description: ID of the booking that is attached to this time entry
              type: integer
              example: 872383
          type: object
    extendedModelMeta:
      title: Extended Meta Model
      properties:
        created_id:
          description: The unique ID of the person (user) who created this record
          type: integer
          readOnly: true
          example: 3
        created:
          description: The UNIX time value of the creation time
          type: integer
          readOnly: true
          example: 1388552400
        created_name:
          description: The full name of the person (user) who created this record
          type: string
          readOnly: true
          example: John Smith
        updated_id:
          description: The unique ID of the person (user) who last updated this record
          type: integer
          readOnly: true
          example: 3
        updated:
          description: The UNIX time value of the last update
          type: integer
          readOnly: true
          example: 1388552400
        updated_name:
          description: The full name of the person (user) who last updated this record
          type: string
          readOnly: true
          example: John Smith
      type: object
    meta:
      title: Page Meta Model
      properties:
        total:
          type: integer
          example: 1
        count:
          type: integer
          example: 1
        per_page:
          type: integer
          example: 1
        current_page:
          type: integer
          example: 1
      type: object
  securitySchemes:
    bearer:
      type: http
      scheme: bearer

````